﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by AsyncGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------


using System;
using System.Collections;
using System.Reflection;
using NHibernate.Cfg;
using NHibernate.Criterion;
using NUnit.Framework;
using Environment=NHibernate.Cfg.Environment;

namespace NHibernate.Test.Naturalid.Mutable
{
	using System.Threading.Tasks;
	[TestFixture]
	public class MutableNaturalIdFixtureAsync : TestCase
	{
		protected override string MappingsAssembly
		{
			get { return "NHibernate.Test"; }
		}

		protected override string[] Mappings
		{
			get { return new string[] {"Naturalid.Mutable.User.hbm.xml"}; }
		}

		protected override void Configure(Configuration configuration)
		{
			cfg.SetProperty(Environment.UseSecondLevelCache, "true");
			cfg.SetProperty(Environment.UseQueryCache, "true");
			cfg.SetProperty(Environment.GenerateStatistics, "true");
		}

		[Test]
		public async Task ReattachmentNaturalIdCheckAsync()
		{
			ISession s = OpenSession();
			s.BeginTransaction();
			User u = new User("gavin", "hb", "secret");
			await (s.PersistAsync(u));
			await (s.Transaction.CommitAsync());
			s.Close();

			FieldInfo name = u.GetType().GetField("name",
			                                      BindingFlags.Instance | BindingFlags.NonPublic | BindingFlags.DeclaredOnly);
			name.SetValue(u, "Gavin");
			s = OpenSession();
			s.BeginTransaction();
			try
			{
				await (s.UpdateAsync(u));
				await (s.Transaction.CommitAsync());
			}
			catch (HibernateException)
			{
				await (s.Transaction.RollbackAsync());
			}
			catch (Exception)
			{
					await (s.Transaction.RollbackAsync());
			}
			finally
			{
				s.Close();
			}

			s = OpenSession();
			s.BeginTransaction();
			await (s.DeleteAsync(u));
			await (s.Transaction.CommitAsync());
			s.Close();
		}

		[Test]
		public async Task NonexistentNaturalIdCacheAsync()
		{
			Sfi.Statistics.Clear();

			ISession s = OpenSession();
			ITransaction t = s.BeginTransaction();

			object nullUser =
				await (s.CreateCriteria(typeof (User)).Add(Restrictions.NaturalId().Set("name", "gavin").Set("org", "hb")).SetCacheable(
					true).UniqueResultAsync());

			Assert.That(nullUser, Is.Null);

			await (t.CommitAsync());
			s.Close();

			Assert.AreEqual(1, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCacheHitCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCachePutCount);

			s = OpenSession();
			t = s.BeginTransaction();

			User u = new User("gavin", "hb", "secret");
			await (s.PersistAsync(u));

			await (t.CommitAsync());
			s.Close();

			Sfi.Statistics.Clear();

			s = OpenSession();
			t = s.BeginTransaction();

			u =
				(User)
				await (s.CreateCriteria(typeof (User)).Add(Restrictions.NaturalId().Set("name", "gavin").Set("org", "hb")).SetCacheable(
					true).UniqueResultAsync());

			Assert.That(u, Is.Not.Null);

			await (t.CommitAsync());
			s.Close();

			Assert.AreEqual(1, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCacheHitCount);
			Assert.AreEqual(1, Sfi.Statistics.QueryCachePutCount);

			Sfi.Statistics.Clear();

			s = OpenSession();
			t = s.BeginTransaction();

			u =
				(User)
				await (s.CreateCriteria(typeof (User)).Add(Restrictions.NaturalId().Set("name", "gavin").Set("org", "hb")).SetCacheable(
					true).UniqueResultAsync());

			await (s.DeleteAsync(u));

			await (t.CommitAsync());
			s.Close();

			Assert.AreEqual(0, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(1, Sfi.Statistics.QueryCacheHitCount);

			Sfi.Statistics.Clear();

			s = OpenSession();
			t = s.BeginTransaction();

			nullUser =
				await (s.CreateCriteria(typeof (User)).Add(Restrictions.NaturalId().Set("name", "gavin").Set("org", "hb")).SetCacheable(
					true).UniqueResultAsync());

			Assert.That(nullUser, Is.Null);

			await (t.CommitAsync());
			s.Close();

			Assert.AreEqual(1, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCacheHitCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCachePutCount);
		}

		[Test]
		public async Task NaturalIdCacheAsync()
		{
			ISession s = OpenSession();
			ITransaction t = s.BeginTransaction();

			User u = new User("gavin", "hb", "secret");
			await (s.PersistAsync(u));

			await (t.CommitAsync());
			s.Close();

			Sfi.Statistics.Clear();

			s = OpenSession();
			t = s.BeginTransaction();

			u = (User) await (s.CreateCriteria(typeof (User))
				.Add(Restrictions.NaturalId().Set("name", "gavin").Set("org", "hb"))
				.SetCacheable(true).UniqueResultAsync());

			Assert.That(u, Is.Not.Null);

			await (t.CommitAsync());
			s.Close();

			Assert.AreEqual(1, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCacheHitCount);
			Assert.AreEqual(1, Sfi.Statistics.QueryCachePutCount);

			s = OpenSession();
			t = s.BeginTransaction();

			User v = new User("xam", "hb", "foobar");
			await (s.PersistAsync(v));

			await (t.CommitAsync());
			s.Close();

			Sfi.Statistics.Clear();

			s = OpenSession();
			t = s.BeginTransaction();

			u = (User) await (s.CreateCriteria(typeof (User))
				.Add(Restrictions.NaturalId().Set("name", "xam").Set("org", "hb"))
				.SetCacheable(true).UniqueResultAsync());

			Assert.That(u, Is.Not.Null);
			Assert.AreEqual(1, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(0, Sfi.Statistics.QueryCacheHitCount);

			u = (User)await (s.CreateCriteria(typeof(User))
				.Add(Restrictions.NaturalId().Set("name", "gavin").Set("org", "hb"))
				.SetCacheable(true).UniqueResultAsync());
			Assert.That(u, Is.Not.Null);
			Assert.AreEqual(1, Sfi.Statistics.QueryExecutionCount);
			Assert.AreEqual(1, Sfi.Statistics.QueryCacheHitCount);

			await (t.CommitAsync());
			s.Close();


			s = OpenSession();
			t = s.BeginTransaction();
			await (s.DeleteAsync("from User"));
			await (t.CommitAsync());
			s.Close();
		}

		[Test]
		public async Task QueryingAsync()
		{
			ISession s = OpenSession();
			ITransaction t = s.BeginTransaction();

			User u = new User("emmanuel", "hb", "bh");
			await (s.PersistAsync(u));

			await (t.CommitAsync());
			s.Close();

			s = OpenSession();
			t = s.BeginTransaction();

			u = (User) await (s.CreateQuery("from User u where u.name = :name").SetParameter("name", "emmanuel").UniqueResultAsync());
			Assert.AreEqual("emmanuel", u.Name);
			await (s.DeleteAsync(u));

			await (t.CommitAsync());
			s.Close();
		}
	}
}